import { useBoolean } from "../index";
import useEventListener from "../useEventListener";
function useHover(target, options) {
  const { onEnter, onLeave } = options || {};
  const [state, { setTrue, setFalse }] = useBoolean(false);
  useEventListener(
    "mouseenter",
    () => {
      onEnter == null ? void 0 : onEnter();
      setTrue();
    },
    {
      target
    }
  );
  useEventListener(
    "mouseleave",
    () => {
      onLeave == null ? void 0 : onLeave();
      setFalse();
    },
    {
      target
    }
  );
  return state;
}
export {
  useHover as default
};
