import { ref, readonly, unref } from "vue";
import merge from "lodash/merge";
function useSetState(initialState) {
  const getInitialState = () => unref(initialState);
  const state = ref(getInitialState());
  const setMergeState = (patch) => {
    const newState = unref(patch);
    state.value = newState ? merge(state.value, newState) : state.value;
  };
  return [readonly(state), setMergeState];
}
export {
  useSetState as default
};
