import { BasicTarget } from '../utils/domTarget';
export type KeyPredicate = (event: KeyboardEvent) => boolean;
export type keyType = number | string;
export type KeyFilter = keyType | keyType[] | ((event: KeyboardEvent) => boolean);
export type EventHandler = (event: KeyboardEvent) => void;
export type KeyEvent = 'keydown' | 'keyup';
export type Target = BasicTarget<HTMLElement | Document | Window>;
export type Options = {
    events?: KeyEvent[];
    target?: Target;
    exactMatch?: boolean;
};
declare function useKeyPress(keyFilter: KeyFilter, eventHandler: EventHandler, option?: Options): void;
export default useKeyPress;
