"use strict";
const vue = require("vue");
const useAutoRunPlugin = (fetchInstance, { manual, ready = true, defaultParams = [], refreshDeps = [], refreshDepsAction }) => {
  const hasAutoRun = vue.ref(false);
  hasAutoRun.value = false;
  vue.watch(vue.isRef(ready) ? ready : [], (r) => {
    if (!manual && r) {
      hasAutoRun.value = true;
      fetchInstance.run(...defaultParams);
    }
  });
  vue.watch(
    refreshDeps,
    () => {
      if (hasAutoRun.value)
        return;
      if (!manual) {
        if (refreshDepsAction) {
          refreshDepsAction();
        } else {
          fetchInstance.refresh();
        }
      }
    },
    {
      deep: true
    }
  );
  return {
    onBefore: () => {
      if (!vue.unref(ready)) {
        return {
          stopNow: true
        };
      }
    }
  };
};
useAutoRunPlugin.onInit = ({ ready = true, manual }) => {
  return {
    loading: !manual && vue.unref(ready)
  };
};
module.exports = useAutoRunPlugin;
